<?php

namespace App\Router\Middleware;
use App\Router\Session;
use Network\IAuthService;
use Shared\Log;
use App\Router\Request\IRequest;
use App\Router\Response\RedirectResponse;
class AuthMiddleware extends Middleware {

    private IAuthService $auth;
    public function __construct(IAuthService $auth) {
        $this->auth = $auth;
    }
    public function handle(IRequest $request, callable $next) {
        $excludedUrls = ['/login', '/register','/forgetPassword', '/', '/api', '/api/activities'];
//        Log::dd($this->auth->getCurrentUser());
        $excludedPrefixes = ['/api/activities'];

        // Vérifier si l'URL actuelle commence par l'un des préfixes exclus, pour /api/activities/1 par exemple
        foreach ($excludedPrefixes as $prefix) {
//            Log::dd($request->getRequestUri());
            if (strpos($request->getRequestUri(), $prefix) === 0) {
                // Si c'est le cas, passer à la requête suivante sans appliquer le middleware
                return parent::handle($request, $next);
            }
        }

        if ($this->auth->getCurrentUser() === null && !in_array($request->getRequestUri(), $excludedUrls)) {
            $resp = new RedirectResponse("/login");
            $resp->send();
            exit;
        }        
        return parent::handle($request, $next);
    }
}